<template>
  <div :class="$style.book" v-if="book">
    <div :class="$style.top">
      <div :class="$style.imageWrap">
        <div
          v-if="book.imageUrl"
          :class="$style.image"
          :style="{ backgroundImage: `url('${book.imageUrl}')` }"
        />
      </div>
      <div :class="$style.info">
        <h2 :class="$style.title">{{ book.title }}</h2>
        <div :class="$style.attrebutes">
          <label-text v-if="book.author">
            <span slot="label">Автор:</span>
            <span slot="text">{{ book.author }}</span>
          </label-text>
          <label-text v-if="book.date">
            <span slot="label">Год:</span>
            <span slot="text">{{ book.date }}</span>
          </label-text>
        </div>
        <div :class="$style.rateBlock">
          <rate :class="$style.rate" :rating="book.rating" />
          <label-text>
            <span slot="label">Рейтинг:</span>
            <span slot="text">{{ book.rating }}</span>
          </label-text>
        </div>
      </div>
    </div>
    <div :class="$style.description" v-if="book.description">
      <h4 :class="$style.descrriptionLabel">Отрывок книги</h4>
      <div v-html="book.description" />
    </div>
  </div>
</template>

<script>
import { Rate, LabelText } from "@/components/ui";

export default {
  name: "BookPage",
  components: { Rate, LabelText },
  data() {
    return {
      id: ""
    };
  },
  computed: {
    book() {
      return this.$store.state.book;
    }
  },
  beforeRouteEnter(to, from, next) {
    next(vm => vm.updateBook(to.params.id));
  },
  beforeRouteUpdate(to, from, next) {
    this.updateBook(to.params.id);
    next();
  },
  mounted() {
    this.updateBook(this.$route.params.id);
  },
  methods: {
    updateBook(id) {
      this.$store.dispatch("getBook", id);
    }
  }
};
</script>

<style lang="scss" module>
@import "../shared/styles/imports.scss";

.book {
  padding: $mainPadding 40px $mainPadding $mainPadding;
  background-color: $mainBgColor;
  min-height: calc(100vh - #{$mainPadding} * 2);

  @include onScreenRes($mobile) {
    padding: 0 16px 24px;
  }
}

.top {
  display: flex;
  margin-bottom: 51px;

  @include onScreenRes($mobile) {
    flex-direction: column;
  }
}

.imageWrap {
  position: relative;
  width: 177px;
  margin-right: 32px;

  @include onScreenRes($mobile) {
    width: calc(100% + 32px);
    margin: 0 0 0 -16px;
  }
}

.image {
  @include backgroundCover();

  width: 100%;
  padding-top: 153%;
  box-shadow: 0px 8px 16px rgba(0, 0, 0, 0.3);
}

.title {
  margin: 0 0 16px;
}

.rateBlock {
  display: flex;
}

.rate {
  margin-right: 14px;
}

.info {
  flex: 1;

  @include onScreenRes($mobile) {
    margin-top: 24px;
  }
}

.attrebutes {
  margin-bottom: 14px;

  & > * {
    display: block;
    margin-bottom: 4px;
  }
}

.description > * {
  font-size: 15px;
  line-height: 24px;
}

.descrriptionLabel {
  font-weight: 500;
  font-size: 19px;
  line-height: 24px;
}
</style>
